<?php

namespace App\Service;

use App\Model\FinanceDetail;
use Illuminate\Support\Facades\DB;
use Mockery\Exception;

class CallBackService extends Service
{
    const SUCCESS = 'PAY_SUCCESS';
    const FAILED = 'PAY_FAIL';

    public function confirmMoneyCallBack($data){
        try {
            $data = json_decode($data,true);
            if(empty($data)) return;

            if($data['status'] == self::FAILED || $data['status'] == self::SUCCESS){
                DB::beginTransaction();

                $obj = FinanceDetail::where('order_number',$data['platOrderId'])->first();
                if(! $obj) return;
                $obj->utr = $data['utr'] ?? '';
                $obj->msg = $data['msg'] ?? '';

                if($data['status'] == self::FAILED){
                    $obj->payment_status = -1;
                }else{
                    $obj->payment_status = 2;
                }
                $obj->save();

                DB::commit();
            }
        }catch (Exception $exception){
            DB::rollBack();
            return;
        }
    }
}
